-- License CC0 (Creative Commons license) (c) darkfrei, 2021

function addSegment ()
	local lastSegment = road[#road]
	local w = lastSegment.w
	local da = math.random (-1, 1)
	local a = lastSegment.a + da
	local v = lastSegment.v + a
	if v>tileSize then
		v = tileSize
		a = -a
	elseif v < -tileSize then
		v = -tileSize
		a = -a
	end
	local x = lastSegment.x + v
	table.insert (road, {x=x,w=w,v=v,a=a})
end

function generateNewRoad ()
	traveledDistance = 0
--	local x = math.random (12, 3*12)/40*width
	local x = math.random (0.25*width, 0.75*width)
	local w = 0.125*width
	
	road = {}
	
	local da, a, v = 0, 0, 0
	
	for i = 1, 29 do
		
--		x = x + math.random (-tileSize, tileSize)
		da = math.random (-1, 1)
		a = a+da
		v = v+a
--		v= v>tileSize and tileSize or v < -tileSize and -tileSize or v
		if v>tileSize then
			v = tileSize
			a = -a
		elseif v < -tileSize then
			v = -tileSize
			a = -a
		end
		x = x + v
		table.insert (road, {x=x,w=w,v=v,a=a})
		x= x>0.75*width and 0.75*width or x < 0.25*width and 0.25*width or x
		
	end
end

function love.load()
	love.window.setMode(1920, 1080, {resizable=true, borderless=false})
	width, height = love.graphics.getDimensions( )

	
	traveledDistance = 0
	tileSize = 40
	generateNewRoad ()
	
	speed = 20
end

 
function love.update(dt)
	traveledDistance = traveledDistance + dt*speed
	local imin = math.floor (traveledDistance/tileSize)+29
	if not road[imin] then
		addSegment ()
	end
	
	speed = speed + dt
end


function love.draw()
	local imin = math.floor (traveledDistance/tileSize)+1
--	local imin = 1
--	local dy = (traveledDistance - (imin-1)*tileSize)
	local dy = traveledDistance
	
	local x, w = road[imin].x, road[imin].w
	local x1, x2 = x-w/2, x+w/2
	for i = imin+1, imin+28 do
		x, w = road[i].x, road[i].w
		local nx1, nx2 = x-w/2, x+w/2
		local y1 = height-(i-2)*tileSize
		local y2 = height-(i-1)*tileSize
		
		if i%4 < 2 then
			love.graphics.setColor(0.1,.1,.1)
		else
			love.graphics.setColor(0.2,.2,.2)
		end
		love.graphics.polygon('fill', x1, y1+dy, nx1, y2+dy, nx2, y2+dy, x2, y1+dy)
		
		love.graphics.setColor(1,1,1)
		love.graphics.line (x1, y1+dy, nx1, y2+dy)
		love.graphics.line (x2, y1+dy, nx2, y2+dy)
		
		x1, x2 = nx1, nx2
	end
	
end

function love.keypressed(key, scancode, isrepeat)
	if false then
	elseif key == "escape" then
		love.event.quit()
	elseif key == "space" then
		generateNewRoad ()
	end
end

function love.mousepressed( x, y, button, istouch, presses )
	if button == 1 then -- left mouse button
	elseif button == 2 then -- right mouse button
	end
end

function love.mousemoved( x, y, dx, dy, istouch )
end

function love.mousereleased( x, y, button, istouch, presses )
	if button == 1 then -- left mouse button
	elseif button == 2 then -- right mouse button
	end
end